unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, MathEdit;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    Edit1: TEdit;
    procedure IntEdit1Enter(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.IntEdit1Enter(Sender: TObject);
  begin
  Label2.caption := '';
  end;

procedure TForm1.Button1Click(Sender: TObject);
  var n, tt,
      found : Integer;
  begin
  n := StrToInt(Edit1.Text);
  found := 0;
  tt := 2;
  While (tt < n) and (found = 0) do
    If n MOD tt = 0 then
      found := 1
    else
      tt := tt + 1;
  If found > 0 then
    Label2.Caption := '... ist teilbar durch ' + IntToStr(tt)
  else
    Label2.Caption := '... ist wirklich eine Primzahl!';
  end;


{ Es folgt die effizientere Alternative, fr die man aber mehr Mathematik
  investieren muss:
  a) Wenn die Zahl n grer als 2 ist, kann sie nur noch eine Primzahl
     sein, wenn sie ungerade ist. Eine ungerade Zahl kann aber keinen
     geraden Teiler haben; also mssen wir nur noch unter den ungeraden
     Zahlen nach einem mglichen Teiler t suchen!
  b) Weil zu jedem Teiler t von n auch n/t ein Teiler ist (nmlich der
     "Komplementr-Teiler" zu t), mssen wir nur solange suchen, bis
     t = n/t, also bis t grer geworden ist als die Wurzel aus n.      }

{
procedure TForm1.Button1Click(Sender: TObject);
  var n, tt, g,
      found : Integer;
  begin
  n := StrToInt(Edit1.Text);
  g := Round(Sqrt(n)) + 1;  // Grenze fr die Gre echter Teiler berechnen
  tt := 2;
  if n Mod 2 = 0 then       // Erst Teilbarkeit durch 2 testen.....
    found := 1
  else begin
    found := 0;
    tt := 3;                // ...dann nur noch ungerade Teiler testen !
    While (tt < g) and (found = 0) do
      If n MOD tt = 0 then
        found := 1
      else
        tt := tt + 1;
    end;
  If found > 0 then
    Edit2.Text := '... ist teilbar durch ' + IntToStr(tt)
  else
    Edit2.Text := '... ist wirklich eine Primzahl!';
  end;
}


end.
